<template>
  <div>
    <CInputCheckbox
      v-for="(item, index) in list"
      :key="index"
      :name="name"
      :label="item.name"
      :value="item.id"
      custom
      :inline="inline"
      :checked="getChecked(item)"
      @update:checked="(value, $event) => setChecked(value, $event, item)"
    />
  </div>
</template>

<script>
import { xor } from 'lodash'

export default {
  name: 'AppCheckboxGroup',

  props: {
    /**
     * Data list
     */
    list: {
      type: Array,
      default: () => []
    },

    /**
     * V-model value
     */
    value: {
      type: Array,
      default: () => []
    },

    /**
     * Input name
     */
    name: {
      type: String,
      default: 'checkbox'
    },

    /**
     * Inline
     */
    inline: {
      type: Boolean,
      default: true
    }
  },

  computed: {
    idList () {
      return this.value.map(item => item.id)
    }
  },

  methods: {
    /**
     * V-model event
     * @param {Boolean} state
     * @param {Object} event
     * @param {Object} item
     */
    setChecked (state, event, item) {
      const checkedIds = xor(this.idList, [parseInt(event.target.value)])
      const checkedList = this.list.filter(item => checkedIds.includes(item.id))
      this.$emit('input', checkedList)
    },

    /**
     * get checked state
     * @param {Object} obj
     * @return {Boolean} checked state
     */
    getChecked (obj) {
      return this.idList.includes(obj.id)
    }
  }
}
</script>
